---
title: WindowClient
slug: Web/API/WindowClient
tags:
  - API
  - Client
  - Experimental
  - Interface
  - Reference
  - Service Workers
  - ServiceWorker
  - WindowClient
---
<p>{{APIRef("Service Workers API")}}</p>

<p>The <code>WindowClient</code> interface of the <a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a> represents the scope of a service worker client that is a document in a browsing context, controlled by an active worker. The service worker client independently selects and uses a service worker for its own loading and sub-resources.</p>

<h2 id="Methods">Methods</h2>

<p><em><code>WindowClient</code> inherits methods from its parent interface, {{domxref("Client")}}.</em></p>

<dl>
 <dt>{{domxref("WindowClient.focus()")}}</dt>
 <dd>Gives user input focus to the current client. </dd>
 <dt>{{domxref("WindowClient.navigate()")}}</dt>
 <dd>Loads a specified URL into a controlled client page.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em><code>WindowClient</code> inherits properties from its parent interface, {{domxref("Client")}}.</em></p>

<dl>
 <dt>{{domxref("WindowClient.focused")}} {{readonlyInline}}</dt>
 <dd>A boolean that indicates whether the current client has focus.</dd>
 <dt>{{domxref("WindowClient.visibilityState")}} {{readonlyInline}}</dt>
 <dd>Indicates the visibility of the current client. This value can be one of <code>"hidden"</code>, <code>"visible"</code>, or <code>"prerender"</code>.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">self.addEventListener('notificationclick', function(event) {
  console.log('On notification click: ', event.notification.tag);
  event.notification.close();

  // This looks to see if the current is already open and
  // focuses if it is
  event.waitUntil(clients.matchAll({
    type: "window"
  }).then(function(clientList) {
    for (var i = 0; i &lt; clientList.length; i++) {
      var client = clientList[i];
      if (client.url == '/' &amp;&amp; 'focus' in client) {
        client.focus();
        break;
      }
    }
    if (clients.openWindow)
      return clients.openWindow('/');
  }));
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#windowclient', 'WindowClient')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.WindowClient")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise">Promises</a></li>
 <li><a href="/en-US/docs/Web/Guide/Performance/Using_web_workers">Using web workers</a></li>
 <li><a href="/en-US/docs/Web/API/Channel_Messaging_API">Channel Messaging API</a></li>
</ul>
